﻿Option Infer On
Option Explicit On
Option Strict On

Imports System

Public Class Customer

   Private _firstName As String
   Public Property FirstName() As String
      Get
         Return _firstName
      End Get
      Set(ByVal value As String)
         _firstName = value
      End Set
   End Property

   Private _lastName As String
   Public Property LastName() As String
      Get
         Return _lastName
      End Get
      Set(ByVal value As String)
         _lastName = value
      End Set
   End Property

   Private _phoneNumbers As New List(Of PhoneNumber)
   Public ReadOnly Property PhoneNumbers() As IEnumerable(Of PhoneNumber)
      Get
         Return _phoneNumbers
      End Get
   End Property

   Private _photoUri As String
   Public ReadOnly Property PhotoUri() As String
      Get
         Return FirstName & LastName & ".jpg"
      End Get
   End Property


   Public Shared Function GetDummyData() As IEnumerable(Of Customer)
      Dim list As New List(Of Customer)
      list.Add(New Customer With {.FirstName = "Joe", .LastName = "Smith"})
      list(0)._phoneNumbers.Add(New PhoneNumber With {.Description = "Home", .Number = "999-555-1111"})
      list.Add(New Customer With {.FirstName = "John", .LastName = "Jones"})
      list(1)._phoneNumbers.Add(New PhoneNumber With {.Description = "Home", .Number = "999-555-2222"})
      list(1)._phoneNumbers.Add(New PhoneNumber With {.Description = "Cell", .Number = "999-555-3333"})
      list.Add(New Customer With {.FirstName = "George", .LastName = "Green"})
      list(2)._phoneNumbers.Add(New PhoneNumber With {.Description = "Home", .Number = "999-555-4444"})
      Return list
   End Function
End Class

Public Class PhoneNumber

   Private _number As String
   Public Property Number() As String
      Get
         Return _number
      End Get
      Set(ByVal value As String)
         _number = value
      End Set
   End Property

   Private _description As String
   Public Property Description() As String
      Get
         Return _description
      End Get
      Set(ByVal value As String)
         _description = value
      End Set
   End Property

End Class
